Project Chrono: chrono::ChContactMaterial Class Reference

Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | List of all members
chrono::ChContactMaterial Class Referenceabstract

## Description

Base class for specifying material properties for contact force generation.

`#include <ChContactMaterial.h>`

Inheritance diagram for chrono::ChContactMaterial:
[legend]

## Public Member Functions
virtual ChContactMaterial * | Clone () const =0
| "Virtual" copy constructor.
virtual ChContactMethod | GetContactMethod () const =0
void | SetStaticFriction (float val)
| Set the static friction coefficient.
float | GetStaticFriction () const
| Get the static friction coefficient.
void | SetSlidingFriction (float val)
| Set the sliding (kinetic) friction coefficient.
float | GetSlidingFriction () const
| Get the sliding friction coefficient.
void | SetFriction (float val)
| Set both static friction and sliding friction at once, with same value.
void | SetRollingFriction (float val)
| Set the rolling friction coefficient (default: 0).
float | GetRollingFriction () const
| Get the rolling friction coefficient.
void | SetSpinningFriction (float val)
| Set the spinning friction coefficient (default: 0).
float | GetSpinningFriction () const
| Get the roliung friction coefficient.
void | SetRestitution (float val)
| Set the ormal coefficient of restitution (default: 0).
float | GetRestitution () const
| Get the coefficient of restitution.
virtual void | ArchiveOut (ChArchiveOut &archive_out)
| Method to allow serialization of transient data to archives.
virtual void | ArchiveIn (ChArchiveIn &archive_in)
| Method to allow deserialization of transient data from archives.

## Static Public Member Functions
static std::shared_ptr< ChContactMaterial > | DefaultMaterial (ChContactMethod contact_method)
| Construct and return a contact material of the specified type with default properties.

## Public Attributes
float | static_friction
| static coefficient of friction
float | sliding_friction
| sliding coefficient of friction
float | rolling_friction
| rolling coefficient of friction
float | spinning_friction
| spinning coefficient of friction
float | restitution
| coefficient of restitution

## Protected Member Functions
| ChContactMaterial (const ChContactMaterial &other)

## Member Function Documentation

## ◆ ArchiveIn()

void chrono::ChContactMaterial::ArchiveIn | ( | ChArchiveIn & | archive_in | ) |
| virtual

Method to allow deserialization of transient data from archives.

Reimplemented in chrono::ChContactMaterialNSC, and chrono::ChContactMaterialSMC.

## ◆ ArchiveOut()

void chrono::ChContactMaterial::ArchiveOut | ( | ChArchiveOut & | archive_out | ) |
| virtual

Method to allow serialization of transient data to archives.

Reimplemented in chrono::ChContactMaterialNSC, and chrono::ChContactMaterialSMC.

## ◆ Clone()

virtual ChContactMaterial * chrono::ChContactMaterial::Clone | ( |  | ) | const
| pure virtual

"Virtual" copy constructor.

Implemented in chrono::ChContactMaterialNSC, and chrono::ChContactMaterialSMC.

## ◆ SetRestitution()

void chrono::ChContactMaterial::SetRestitution | ( | float | val | ) |
| inline

Set the ormal coefficient of restitution (default: 0).

In the range [0,1].

## ◆ SetRollingFriction()

void chrono::ChContactMaterial::SetRollingFriction | ( | float | val | ) |
| inline

Set the rolling friction coefficient (default: 0).

Usually around 1E-3.

## ◆ SetSpinningFriction()

void chrono::ChContactMaterial::SetSpinningFriction | ( | float | val | ) |
| inline

Set the spinning friction coefficient (default: 0).

Usually around 1E-3.

## ◆ SetStaticFriction()

void chrono::ChContactMaterial::SetStaticFriction | ( | float | val | ) |
| inline

Set the static friction coefficient.

Usually in 0..1 range, rarely above. Default 0.6.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChContactMaterial.h
- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChContactMaterial.cpp